using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

using TAPI;
using Terraria;
using Terraria.ID;

namespace tSouchy.noCorruption
{

    public class MWorld : TAPI.ModWorld
    {

        // small    = 4200      = 3 iles total      = 1 normal, 1 corrup, 1 hallow
        // medium   = 6400      = 6 iles total      = 2 normal, 2 corrup, 2 hallow
        // big      = 8400      = 8 iles total      = 3 normal, 3 corrup, 2 hallow
        public static int islandChestCount = 0;
        public static List<int> corruptionChestContents = new List<int>() { ItemID.ShinyRedBalloon, ItemID.Starfury, ItemID.LuckyHorseshoe, ItemID.ShadowOrb};
        public static List<int> crimsonChestContents = new List<int>() { ItemID.ShinyRedBalloon, ItemID.Starfury, ItemID.LuckyHorseshoe};
        public static List<int> hallowedChestContents = new List<int>() { ItemID.GoldCoin };
        public static List<int> normalChestContents = new List<int>() { ItemID.ShinyRedBalloon, ItemID.Starfury, ItemID.LuckyHorseshoe};
        public static int numIslandHouses = 0;
        public static int houseCount = 0;
        public static int[] fihX = new int[300];
        public static int[] fihY = new int[300];
        public static SpreadType[] spreads = new SpreadType[300];

        // avant la gen
        public override void WorldGenPostInit() {
            // Sets the world type
            if (!MBase.getStrOption("worldType").Equals("Random")) {
                WorldGen.corruption = MBase.getStrOption("worldType").Equals("Corruption");
                WorldGen.crimson = MBase.getStrOption("worldType").Equals("Crimson");
            }
        }

        // pendant la gen
        public override void WorldGenModifyTaskList(List<WorldGenTask> list) {
            // Enlve la gnration de corruption et d'altars
            if (MBase.getBoolOption("RemoveOldNormalModeGen")) {
                list.Remove(list.Find(t => t.name.Equals(GenerationTaskNames.Corruption) || t.name.Equals(GenerationTaskNames.Crimson)));
                list.Remove(list.Find(t => t.name.Equals(GenerationTaskNames.Altars)));
            }

            // Replace le findspawn au dbut de la liste de gnration
            WorldGenTask findSpawn = list.Find(t => t.name.Equals(GenerationTaskNames.FindSpawn));
            list.Remove(findSpawn);
            list.Insert(1, findSpawn);

            // Insert les SouchyIslands juste avant les FloatingIslands originales
            if (MBase.getBoolOption("AddNewNormalModeGen")) {
                // Remplace la gnration de maisons d'iles
                int index2 = list.IndexOf(list.Find(t => t.name.Equals(GenerationTaskNames.IslandHouses)));
                list.RemoveAt(index2);
                list.Insert(index2 + 1, new WorldGenTask.Action("TAPI:IslandHouses", WorldGenImp.IslandHousesTask));
                // Remplace la gnration d'iles et ajoute les nouvelles
                int index = list.IndexOf(list.Find(t => t.name.Equals(GenerationTaskNames.FloatingIslands)));
                list.RemoveAt(index);
                list.Insert(index, new WorldGenTask.Action("TAPI:SouchyIslands", SouchyIslandsTask));
                list.Insert(index, new WorldGenTask.Action("TAPI:FloatingIslands", WorldGenImp.FloatingIslandsTask));
            }
            
        }

        // aprs la gen
        public override void WorldGenPostGen() {
            //testIslands();
        }

        public override void WorldGenModifyHardmodeTaskList(List<WorldGenTask> list) {
            if(MBase.getBoolOption("RemoveOldHardModeGen")){
                list.Remove(list.Find(t => t.name.Equals(GenerationTaskNames.BaseHardmode)));
            }
            if (MBase.getBoolOption("AddNewHardModeGen")) {
                list.Add(new WorldGenTask.Action("TAPI:SouchyIslandsHard", SouchyIslandsHardTask));
            }
        }

        public override bool PreHitWire(int x, int y, int wireType) { return true; }

        public override void Save(BinBuffer bb) { }
        public override void Load(BinBuffer bb) { }

        // ------------------------------------------------------------------------------------------------------------------------------------------------------------

        public static void updateStatusText(String text, float percent) {
            Main.statusText = string.Concat(new object[]
			{
			    text,
			    " ",
			    (int)(percent * 100f + 1f),
			    "%"
		    });
        }

        public static void SouchyIslandsTask() {
            String text = "Dropping corruption on floating islands...";
            int count = (int) Math.Floor(Main.maxTilesX / 2800.0); // nombre max d'iles  crer (small = 1, medium = 2, big = 3)
            String option = MBase.getStrOption("numCorrupIslands");
            if (!option.Equals("Automatic")) count = int.Parse(option);
            FloatingIsland(WorldGen.corruption ? SpreadType.Corruption : SpreadType.Crimson, text, count);
        }

        public static void SouchyIslandsHardTask() {
            String text = "Dropping happiness on floating islands...";
            int count = (int) Math.Floor(Main.maxTilesX / 3200.0); // nombre max d'iles  crer (small = 1, medium = 2, big = 2)
            String option = MBase.getStrOption("numHallowIslands");
            if (!option.Equals("Automatic")) count = int.Parse(option);
            FloatingIsland(SpreadType.Hallow, text, count);
        }
        
        public static void furnitureTest() {
            for (int style = -5; style < 150; style++) {
                // chair and banners
                Main.tile[Main.spawnTileX - 20 + style, Main.spawnTileY - 40 + 1].type = TileID.RedBrick;
                Main.tile[Main.spawnTileX - 20 + style, Main.spawnTileY - 40 + 1].active(true);
                // portes
                Main.tile[Main.spawnTileX - 20 + style, Main.spawnTileY - 45 + 1].type = TileID.RedBrick;
                Main.tile[Main.spawnTileX - 20 + style, Main.spawnTileY - 45 + 1].active(true);
                Main.tile[Main.spawnTileX - 20 + style, Main.spawnTileY - 45 - 3].type = TileID.RedBrick;
                Main.tile[Main.spawnTileX - 20 + style, Main.spawnTileY - 45 - 3].active(true);
                // tables
                for (int i = 0; i < 3; i++) {
                    Main.tile[Main.spawnTileX - 20 + (style * 3) + i, Main.spawnTileY - 50 + 1].type = TileID.RedBrick;
                    Main.tile[Main.spawnTileX - 20 + (style * 3) + i, Main.spawnTileY - 50 + 1].active(true);
                }
                // chests
                for (int i = 0; i < 2; i++) {
                    Main.tile[Main.spawnTileX - 20 + (style * 2) + i, Main.spawnTileY - 55].type = TileID.RedBrick;
                    Main.tile[Main.spawnTileX - 20 + (style * 2) + i, Main.spawnTileY - 55].active(true);
                }
            }
            for (int style = 0; style < 150; style++) {
                WorldGen.PlaceTile(Main.spawnTileX - 20 + style, Main.spawnTileY - 40, 15, true, true, 0, style); // chair
                WorldGen.PlaceTile(Main.spawnTileX - 20 + style, Main.spawnTileY - 40 + 2, 91, true, false, -1, style);// banner
                WorldGen.PlaceTile(Main.spawnTileX - 20 + style, Main.spawnTileY - 45, 10, true, false, -1, style);// porte
                WorldGen.PlaceTile(Main.spawnTileX - 20 + (style * 3), Main.spawnTileY - 50, 14, true, false, -1, style);// table
                WorldGen.AddBuriedChest(Main.spawnTileX - 20 + (style * 2), Main.spawnTileY - 55, 0, false, style); // chests
            }
        }

        public static void genSomeOrbs(int baseX, int baseY) {
            // generate from 3 to 7 random shadow orbs
            int numberOfOrbs = 1 + WorldGen.genRand.Next(1, 4) + WorldGen.genRand.Next(1, 4);
            for (int i = 0; i < numberOfOrbs; i++) {
                int x = 0;
                int y = 0;
                Boolean good = false;
                while (!good) {
                    x = WorldGen.genRand.Next(baseX - 50, baseX + 50);
                    y = WorldGen.genRand.Next(baseY, baseY + 50);
                    if (Main.tile[x, y - 1].lava() || Main.tile[x - 1, y - 1].lava()) {
                        continue;
                    }
                    if (!WorldGen.EmptyTileCheck(x - 1, i, y - 1, y, -1)) {
                        continue;
                    }
                    if (!TileDef.solid[(int) Main.tile[x, y].type] || !TileDef.solid[(int) Main.tile[x - 1, y].type]) {
                        continue;
                    }
                    if (TileDef.wallDungeon[(int) Main.tile[x, y].wall]) {
                        continue;
                    }
                    if (Main.tile[x, y].wall == WallID.Cloud || Main.tile[x, y].wall == WallID.None) {
                        continue;
                    }
                    good = true;
                }
                patchOfCorruption(x, y);
                WorldGen.AddShadowOrb(x, y);
            }
        }

        public static void patchOfCorruption(int x, int y) {
            replaceByCorruption(x + 1, y - 2);
            replaceByCorruption(x - 2, y - 2);
            replaceByCorruption(x - 2, y + 1);
            replaceByCorruption(x + 1, y + 1);
            for(int i = -3; i <= 2; i++){
                for(int j = -1; j <= 0; j++){
                    replaceByCorruption(x + i, y + j);
                }
            }
            for(int i = -1; i <= 0; i++){
                for(int j = -3; j <= 2; j++){
                    replaceByCorruption(x + i, y + j);
                }
            }

        }

        public static void replaceByCorruption(int x, int y) {
            Tile tile = Main.tile[x, y];
            if (WorldGen.corruption) {
                switch (tile.type) {
                    case TileID.Sand: tile.type = TileID.Ebonsand; break;
                    case TileID.IceBlock: tile.type = TileID.CorruptIce; break;
                    case TileID.Grass: tile.type = TileID.CorruptGrass; break;
                    case TileID.Plants:
                    case TileID.Plants2: tile.type = TileID.CorruptPlants; break;
                    default: tile.type = TileID.Ebonstone; break;
                }
                tile.wall = WallID.EbonstoneUnsafe;
            } else if (WorldGen.crimson) {
                switch (tile.type) {
                    case TileID.Sand: tile.type = TileID.Crimsand; break;
                    case TileID.IceBlock: tile.type = TileID.RedIce; break;
                    case TileID.Grass: tile.type = TileID.FleshGrass; break;
                    case TileID.Plants:
                    case TileID.Plants2: tile.type = TileID.FleshWeeds; break;
                    default: tile.type = TileID.Crimstone; break;
                }
                tile.wall = WallID.CrimstoneUnsafe;
            }
        }

        public static bool isAdjacentTo(int x, int y, int type) {
            return (
                    Main.tile[x - 1, y - 1].type == type ||
                    Main.tile[x, y - 1].type == type ||
                    Main.tile[x + 1, y - 1].type == type ||
                    Main.tile[x - 1, y].type == type ||
                    Main.tile[x + 1, y].type == type ||
                    Main.tile[x - 1, y].type == type ||
                    Main.tile[x, y + 1].type == type ||
                    Main.tile[x - 1, y + 1].type == type
                    );
        }

        public static void FloatingIsland(SpreadType type, String text, int count) {
            if (count <= 0) count = (int) ((double) Main.maxTilesX * 0.0008);
            int spaceLeft = 150; // 180
            int spaceRight = 150; // 180
            float mem = count;

            while(count > 0){

                float percent = ((mem - count) / mem);//(float) i / (float) Main.maxTilesX;
                MWorld.updateStatusText(text, percent);
                int echecs = 0;
                bool flag = false;
                bool flag2 = false;
                int n = WorldGen.genRand.Next((int) ((double) Main.maxTilesX * 0.1), (int) ((double) Main.maxTilesX * 0.9));

                while (!flag2) {
                    flag2 = true;
                    // si trop prs du centre de la map, refait un jet alatoire
                    //while (n > Main.maxTilesX / 2 - 80 && n < Main.maxTilesX / 2 + 80) {
                    //    n = WorldGen.genRand.Next((int) ((double) Main.maxTilesX * 0.1), (int) ((double) Main.maxTilesX * 0.9));
                    //}
                    // si trop prs d'une autre ile, recommence le while
                    for (int j = 0; j < MWorld.numIslandHouses; j++) {
                        if (n > MWorld.fihX[j] - spaceLeft && n < MWorld.fihX[j] + spaceRight) {
                            echecs++;
                            flag2 = false;
                            break;
                        }
                    }
                    // si trop d'checs, recommence le for
                    if (echecs >= 500) {
                        flag = true;
                        break;
                    }
                }
                if (!flag) {
                    int m = 200;
                    while ((double) m < Main.worldSurface) {
                        if (Main.tile[n, m].active()) {
                            int n2 = n;
                            int m2 = WorldGen.genRand.Next(90, m - 100);
                            while ((double) m2 > WorldGen.worldSurfaceLow - 50.0) {
                                m2--;
                            }
                            MWorld.spreads[MWorld.numIslandHouses] = type;
                            MWorld.fihX[MWorld.numIslandHouses] = n2;
                            MWorld.fihY[MWorld.numIslandHouses] = m2;
                            MWorld.numIslandHouses++;
                            count--; 
                            if (type == SpreadType.Normal) {
                                WorldGen.CloudIsland(n2, m2);
                            } else {
                                MWorld.CloudIsland(n2, m2, type);
                                if (Main.hardMode) IslandHouse(n2, m2, SpreadType.Hallow);
                            }
                            break;
                        }
                        m++;
                    }
                }
            }
        }

        public static void CloudIsland(int i, int j, SpreadType spreadType) {

            ushort cloud = TileID.Cloud; //189
            ushort raincloud = TileID.RainCloud; //196
            ushort dirt = TileID.Dirt;
            ushort grass = 0;
            ushort stone = 0;
            ushort wall = 0;

            switch (spreadType) {
                case SpreadType.Hallow:
                    grass = TileID.HallowedGrass; //pearlstone
                    stone = TileID.Pearlstone;
                    wall = WallID.DirtUnsafe; //PearlstoneBrickUnsafe
                    break;
                case SpreadType.Corruption:
                    grass = TileID.CorruptGrass;
                    stone = TileID.Ebonstone;
                    wall = WallID.EbonstoneUnsafe;
                    break;
                case SpreadType.Crimson:
                    grass = TileID.FleshGrass;
                    stone = TileID.Crimstone;
                    wall = WallID.CrimstoneUnsafe;
                    break;
            }

            // Bounds
            int minX = i;
            int maxX = i;
            int minY = i;
            int maxY = j;
            int diameterMinCloud = 150; //100
            int diameterMaxCloud = 150; //150
            int diameterMinDirt = 120; //80
            int diameterMaxDirt = 120; //95

            Vector2 center;
            center.X = (float) i;
            center.Y = (float) j;

            Vector2 offset;
            offset.X = (float) WorldGen.genRand.Next(-20, 21) * 0.2f;

            while (offset.X > -2f && offset.X < 2f) {
                offset.X = (float) WorldGen.genRand.Next(-20, 21) * 0.2f;
            }
            offset.Y = (float) WorldGen.genRand.Next(-20, -10) * 0.02f;

            // Clouds
            double diameter = (double) WorldGen.genRand.Next(diameterMinCloud, diameterMaxCloud); // 100, 150
            float iter = (float) WorldGen.genRand.Next(20, 30); //20, 30
            while (diameter > 0.0 && iter > 0f) {
                diameter -= (double) WorldGen.genRand.Next(4);
                iter -= 1f;

                int minXCloud = (int) ((double) center.X - diameter * 0.5);
                int maxXCloud = (int) ((double) center.X + diameter * 0.5);
                int minYCloud = (int) ((double) center.Y - diameter * 0.5);
                int maxYCloud = (int) ((double) center.Y + diameter * 0.5);

                if (minXCloud < 0) minXCloud = 0;
                if (maxXCloud > Main.maxTilesX) maxXCloud = Main.maxTilesX;
                if (minYCloud < 0) minYCloud = 0;
                if (maxYCloud > Main.maxTilesY) maxYCloud = Main.maxTilesY;

                double distMax = diameter * (double) WorldGen.genRand.Next(80, 120) * 0.01;
                float minY2 = center.Y + 1f; // surface de l'ile

                for (int n = minXCloud; n < maxXCloud; n++) {

                    if (WorldGen.genRand.Next(2) == 0) minY2 += (float) WorldGen.genRand.Next(-1, 2);
                    if (minY2 < center.Y) minY2 = center.Y;
                    if (minY2 > center.Y + 2f) minY2 = center.Y + 2f;

                    for (int m = minYCloud; m < maxYCloud; m++) {
                        if ((float) m > minY2) {
                            float distX = Math.Abs((float) n - center.X);
                            float distY = Math.Abs((float) m - center.Y) * 3f;
                            double distance = Math.Sqrt((double) (distX * distX + distY * distY)); // pythagore
                            if (distance < distMax * 0.4) {
                                if (n < minX) minX = n;
                                if (n > maxX) maxX = n;
                                if (m < minY) minY = m;
                                if (m > maxY) maxY = m;
                                Main.tile[n, m].active(true);
                                Main.tile[n, m].type = cloud;
                                WorldGen.SquareTileFrame(n, m, true);
                            }
                        }
                    }
                }
                // Change le point central de l'ile
                center += offset;
                offset.X += (float) WorldGen.genRand.Next(-20, 21) * 0.05f; // rajoute entre -1 et 1

                if (offset.X > 1f) offset.X = 1f;
                if (offset.X < -1f) offset.X = -1f;
                if ((double) offset.Y > 0.2) offset.Y = -0.2f;
                if ((double) offset.Y < -0.2) offset.Y = -0.2f;
            }

            // Rain Clouds
            int distMax1;
            for (int n1 = minX + WorldGen.genRand.Next(5); n1 < maxX; n1 += WorldGen.genRand.Next(distMax1, (int) ((double) distMax1 * 1.5))) {
                int m1 = maxY;
                while (!Main.tile[n1, m1].active()) {
                    m1--;
                }
                m1 += WorldGen.genRand.Next(-3, 4);
                distMax1 = WorldGen.genRand.Next(4, 8);

                int tileID = cloud;
                if (WorldGen.genRand.Next(4) == 0) tileID = raincloud;

                for (int n2 = n1 - distMax1; n2 <= n1 + distMax1; n2++) {
                    for (int m2 = m1 - distMax1; m2 <= m1 + distMax1; m2++) {
                        if (m2 > minY) {
                            float distX = (float) Math.Abs(n2 - n1);
                            float distY = (float) (Math.Abs(m2 - m1) * 2);
                            double distance = Math.Sqrt((double) (distX * distX + distY * distY));
                            if (distance < (double) (distMax1 + WorldGen.genRand.Next(2))) {
                                Main.tile[n2, m2].active(true);
                                Main.tile[n2, m2].type = (ushort) tileID;
                                WorldGen.SquareTileFrame(n2, m2, true);
                            }
                        }
                    }
                }
            }


            // Dirt (Corruption) part 
            diameter = (double) WorldGen.genRand.Next(diameterMinDirt, diameterMaxDirt); // 80, 95
            iter = (float) WorldGen.genRand.Next(10, 15); // 10, 15

            center.X = (float) i;
            center.Y = (float) minY;

            offset.X = (float) WorldGen.genRand.Next(-20, 21) * 0.2f; // = entre -4 et 4
            while (offset.X > -2f && offset.X < 2f) { // donc on veut qu'il soit entre [-2 et -4] OU entre [2 et 4]
                offset.X = (float) WorldGen.genRand.Next(-20, 21) * 0.2f; // = entre -4 et 4
            }
            offset.Y = (float) WorldGen.genRand.Next(-20, -10) * 0.02f; // = entre -0.4 et -0.2

            while (diameter > 0.0 && iter > 0f) {
                diameter -= (double) WorldGen.genRand.Next(4);
                iter -= 1f;

                int minXDirt = (int) ((double) center.X - diameter * 0.5);
                int maxXDirt = (int) ((double) center.X + diameter * 0.5);
                int minYDirt = minY - 1;
                int maxYDirt = (int) ((double) center.Y + diameter * 0.5);

                if (minXDirt < 0) minXDirt = 0;
                if (maxXDirt > Main.maxTilesX) maxXDirt = Main.maxTilesX;
                if (minYDirt < 0) minYDirt = 0;
                if (maxYDirt > Main.maxTilesY) maxYDirt = Main.maxTilesY;

                double distMax = diameter * (double) WorldGen.genRand.Next(80, 120) * 0.01;
                float minY2 = center.Y + 1f;

                for (int n = minXDirt; n < maxXDirt; n++) {

                    if (WorldGen.genRand.Next(2) == 0) minY2 += (float) WorldGen.genRand.Next(-1, 2);
                    if (minY2 < center.Y) minY2 = center.Y;
                    if (minY2 > center.Y + 2f) minY2 = center.Y + 2f;

                    bool flag = true;
                    for (int m = minYDirt; m < maxYDirt; m++) {
                        if ((float) m > minY2) {
                            float distX = Math.Abs((float) n - center.X);
                            float distY = Math.Abs((float) m - center.Y) * 3f;
                            double distance = Math.Sqrt((double) (distX * distX + distY * distY));
                            if (distance < distMax * 0.4 && Main.tile[n, m].type == cloud) {
                                // Dirt
                                Main.tile[n, m].type = dirt;
                                // Grass
                                if (flag) {
                                    WorldGen.SpreadGrass(n, m, dirt, grass, true, 0);
                                    flag = false;
                                }
                                // Stone
                                int myDist = (int) Math.Abs(maxYDirt - m); 
                                if (WorldGen.genRand.Next(10) == 0) {
                                    Main.tile[n, m].type = stone;
                                }
                                if (myDist < 13 && WorldGen.genRand.Next(6) == 0) {
                                    Main.tile[n, m].type = stone;
                                }
                                if (myDist < 9 && isAdjacentTo(n, m, stone) && WorldGen.genRand.Next(4) == 0) {
                                    Main.tile[n, m].type = stone;
                                }
                                if (myDist < 7 && isAdjacentTo(n, m, stone) && WorldGen.genRand.Next(2) == 0) {
                                    Main.tile[n, m].type = stone;
                                }
                                if (myDist < 6) {
                                    Main.tile[n, m].type = stone;
                                }

                                WorldGen.SquareTileFrame(n, m, true);
                            }
                        }
                    }
                }
                // Change le point central de l'ile
                center += offset;
                offset.X += (float) WorldGen.genRand.Next(-20, 21) * 0.05f; // rajoute entre -1 et 1

                if (offset.X > 1f) offset.X = 1f;
                if (offset.X < -1f) offset.X = -1f;
                if ((double) offset.Y > 0.2) offset.Y = -0.2f;
                if ((double) offset.Y < -0.2) offset.Y = -0.2f;
            }

            // Moar clouds
            {
                int n1 = minX;
                n1 += WorldGen.genRand.Next(5);
                while (n1 < maxX) {
                    int m1 = maxY;
                    while ((!Main.tile[n1, m1].active() || Main.tile[n1, m1].type != 0) && n1 < maxX) {
                        m1--;
                        if (m1 < minY) {
                            m1 = maxY;
                            n1 += WorldGen.genRand.Next(1, 4);
                        }
                    }
                    if (n1 < maxX) {
                        m1 += WorldGen.genRand.Next(0, 4);
                        int distMax = WorldGen.genRand.Next(2, 5);
                        int tileID = cloud;
                        for (int n2 = n1 - distMax; n2 <= n1 + distMax; n2++) {
                            for (int m2 = m1 - distMax; m2 <= m1 + distMax; m2++) {
                                if (m2 > minY) {
                                    float distX = (float) Math.Abs(n2 - n1);
                                    float distY = (float) (Math.Abs(m2 - m1) * 2);
                                    double distance = Math.Sqrt((double) (distX * distX + distY * distY)); // pythagore
                                    if (distance < (double) distMax) {
                                        Main.tile[n2, m2].type = (ushort) tileID;
                                        WorldGen.SquareTileFrame(n2, m2, true);
                                    }
                                }
                            }
                        }
                        n1 += WorldGen.genRand.Next(distMax, (int) ((double) distMax * 1.5));
                    }
                }
            }

            // Addind Walls ?
            for (int n = minX - 20; n <= maxX + 20; n++) {
                for (int m = minY - 20; m <= maxY + 20; m++) {
                    bool flag = true;
                    for (int n2 = n - 1; n2 <= n + 1; n2++) {
                        for (int m2 = m - 1; m2 <= m + 1; m2++) {
                            if (!Main.tile[n2, m2].active()) {
                                flag = false;
                            }
                        }
                    }
                    if (flag) {
                        if (Main.tile[n, m].type == TileID.Cloud || Main.tile[n, m].type == TileID.RainCloud) {
                            Main.tile[n, m].wall = WallID.Cloud;
                        } else {
                            Main.tile[n, m].wall = wall;
                        }
                        WorldGen.SquareWallFrame(n, m, true);
                    }
                }
            }

            // Addind water ?
            for (int n = minX; n <= maxX; n++) {
                int m = minY - 10;
                while (!Main.tile[n, m + 1].active()) {
                    m++;
                }
                if (m < maxY && Main.tile[n, m + 1].type == cloud) {
                    if (WorldGen.genRand.Next(10) == 0) {
                        int num49 = WorldGen.genRand.Next(1, 3);
                        for (int n2 = n - num49; n2 <= n + num49; n2++) {
                            if (Main.tile[n2, m].type == cloud) {
                                Main.tile[n2, m].active(false);
                                Main.tile[n2, m].liquid = 255;
                                Main.tile[n2, m].lava(false);
                                WorldGen.SquareTileFrame(n, m, true);
                            }
                            if (Main.tile[n2, m + 1].type == cloud) {
                                Main.tile[n2, m + 1].active(false);
                                Main.tile[n2, m + 1].liquid = 255;
                                Main.tile[n2, m + 1].lava(false);
                                WorldGen.SquareTileFrame(n, m + 1, true);
                            }
                            if (n2 > n - num49 && n2 < n + 2 && Main.tile[n2, m + 2].type == cloud) {
                                Main.tile[n2, m + 2].active(false);
                                Main.tile[n2, m + 2].liquid = 255;
                                Main.tile[n2, m + 2].lava(false);
                                WorldGen.SquareTileFrame(n, m + 2, true);
                            }
                        }
                    }
                    if (WorldGen.genRand.Next(5) == 0) {
                        Main.tile[n, m].liquid = 255;
                    }
                    Main.tile[n, m].lava(false);
                    WorldGen.SquareTileFrame(n, m, true);
                }
            }

            // Mini islands over the big one
            for (int numberOfMiniIslands = 0; numberOfMiniIslands <= WorldGen.genRand.Next(4); numberOfMiniIslands++) {
                int n = WorldGen.genRand.Next(minX - 5, maxX + 5);
                int m = minY - WorldGen.genRand.Next(20, 40);
                int distMax = WorldGen.genRand.Next(4, 8);
                int tileID = cloud;
                if (WorldGen.genRand.Next(2) == 0) tileID = raincloud;

                for (int n2 = n - distMax; n2 <= n + distMax; n2++) {
                    for (int m2 = m - distMax; m2 <= m + distMax; m2++) {
                        float distX = (float) Math.Abs(n2 - n);
                        float distY = (float) (Math.Abs(m2 - m) * 2);
                        double distance = Math.Sqrt((double) (distX * distX + distY * distY)); // pythagore
                        if (distance < (double) (distMax + WorldGen.genRand.Next(-1, 2))) {
                            if (n2 < 0 || n2 > Main.maxTilesX || m2 < 0 || m2 > Main.maxTilesY) continue;
                            Main.tile[n2, m2].active(true);
                            Main.tile[n2, m2].type = (ushort) tileID;
                            WorldGen.SquareTileFrame(n2, m2, true);
                        }
                    }
                }
                for (int n2 = n - distMax + 2; n2 <= n + distMax - 2; n2++) {
                    int m2 = m - distMax;
                    if (n2 < 0 || n2 > Main.maxTilesX || m2 < 0 || m2 > Main.maxTilesY) continue;
                    while (!Main.tile[n2, m2].active()) {
                        m2++;
                    }
                    Main.tile[n2, m2].active(false);
                    Main.tile[n2, m2].liquid = 255;
                    WorldGen.SquareTileFrame(n2, m2, true);
                }
            }
        }

        public static void IslandHouse(int i, int j, SpreadType spreadType) {

            int type = 0;
            int wall = 0;
            int glass = 0;
            List<int> chestContents = new List<int>();
            int chairStyle = 0;
            int doorStyle = 0;
            int tableStyle = 0;
            int chestStyle = 0;
            int bannerStyle = 0;
            int bannerStyle2 = 0;
            int bannerStyle3 = 0;

            switch (spreadType) {
                case SpreadType.Hallow:
                    type = TileID.PearlstoneBrick;
                    wall = WallID.PearlstoneBrickUnsafe;
                    glass = WallID.RainbowStainedGlass;
                    chestContents = hallowedChestContents;
                    chairStyle = 4;
                    doorStyle = 3;
                    tableStyle = 3;
                    chestStyle = 9;
                    ushort[] hallowedBanners = { 36, 84 };
                    bannerStyle = hallowedBanners[WorldGen.genRand.Next(0, 2)];
                    bannerStyle = hallowedBanners[WorldGen.genRand.Next(0, 2)];
                    bannerStyle = hallowedBanners[WorldGen.genRand.Next(0, 2)];
                    break;
                case SpreadType.Corruption:
                    type = TileID.EbonstoneBrick;
                    wall = WallID.EbonstoneUnsafe;
                    glass = WallID.PurpleStainedGlass;
                    chestContents = corruptionChestContents;
                    chairStyle = 2;
                    doorStyle = 1;
                    tableStyle = 1;
                    chestStyle = 7;
                    ushort[] corruptBanners = { 39, 40, 48, 104 };
                    bannerStyle = corruptBanners[WorldGen.genRand.Next(0, 4)];
                    bannerStyle2 = corruptBanners[WorldGen.genRand.Next(0, 4)];
                    bannerStyle3 = corruptBanners[WorldGen.genRand.Next(0, 4)];
                    break;
                case SpreadType.Crimson:
                    type = TileID.Crimstone;
                    wall = WallID.CrimstoneUnsafe;
                    glass = WallID.RedStainedGlass;
                    chestContents = crimsonChestContents;
                    chairStyle = 8;
                    doorStyle = 5;
                    tableStyle = 5;
                    chestStyle = 43;
                    ushort[] crimsonBanners = { 31, 32, 33 };
                    bannerStyle = crimsonBanners[WorldGen.genRand.Next(0, 3)];
                    bannerStyle2 = crimsonBanners[WorldGen.genRand.Next(0, 3)];
                    bannerStyle3 = crimsonBanners[WorldGen.genRand.Next(0, 3)];
                    break;
                case SpreadType.Normal:
                    type = TileID.Sunplate;
                    wall = WallID.DiscWall;
                    glass = WallID.Glass;
                    chestContents = normalChestContents;
                    chairStyle = 10;
                    doorStyle = 9;
                    tableStyle = 7;
                    chestStyle = 13;
                    bannerStyle = WorldGen.genRand.Next(7, 10);
                    bannerStyle2 = WorldGen.genRand.Next(7, 10);
                    bannerStyle3 = WorldGen.genRand.Next(7, 10);
                    break;
            }

            int minWidth = 7;
            int maxWidth = 12;
            int minHeight = 5;
            int maxHeight = 7;

            Vector2 vector = new Vector2((float) i, (float) j);

            int direction = 1;
            if (WorldGen.genRand.Next(2) == 0) direction = -1;

            int width = WorldGen.genRand.Next(minWidth, maxWidth);
            int height = WorldGen.genRand.Next(minHeight, maxHeight);

            vector.X = (float) (i + (width + 2) * direction);
            for (int n = j - 15; n < j + 30; n++) {
                if (Main.tile[(int) vector.X, n].active()) {
                    vector.Y = (float) (n - 1);
                    break;
                }
            }
            vector.X = (float) i;

            int minX = (int) (vector.X - (float) width - 1f);
            int maxX = (int) (vector.X + (float) width + 1f);
            int minY = (int) (vector.Y - (float) height - 1f);
            int maxY = (int) (vector.Y + 2f);

            if (minX < 0) minX = 0;
            if (maxX > Main.maxTilesX) maxX = Main.maxTilesX;
            if (minY < 0) minY = 0; // min is higher
            if (maxY > Main.maxTilesY) maxY = Main.maxTilesY; // max is lower

            for (int n = minX; n <= maxX; n++) {
                for (int m = minY - 1; m < maxY + 1; m++) {
                    if (m != minY - 1 || (n != minX && n != maxX)) {
                        Main.tile[n, m].active(true);
                        Main.tile[n, m].liquid = 0;
                        Main.tile[n, m].type = (ushort) type;
                        Main.tile[n, m].wall = 0;
                        Main.tile[n, m].halfBrick(false);
                        Main.tile[n, m].slope(0);
                    }
                }
            }

            minX = (int) (vector.X - (float) width);
            maxX = (int) (vector.X + (float) width);
            minY = (int) (vector.Y - (float) height);
            maxY = (int) (vector.Y + 1f);

            if (minX < 0) minX = 0;
            if (maxX > Main.maxTilesX) maxX = Main.maxTilesX;
            if (minY < 0) minY = 0; // min is higher
            if (maxY > Main.maxTilesY) maxY = Main.maxTilesY; // max is lower

            for (int n = minX; n <= maxX; n++) {
                for (int num8 = minY; num8 < maxY; num8++) {
                    if ((num8 != minY || (n != minX && n != maxX)) && Main.tile[n, num8].wall == 0) {
                        Main.tile[n, num8].active(false);
                        Main.tile[n, num8].wall = (ushort) wall;
                    }
                }
            }

            // Door
            int numX9 = i + (width + 1) * direction;
            int numY10 = (int) vector.Y;
            for (int n = numX9 - 2; n <= numX9 + 2; n++) {
                Main.tile[n, numY10].active(false);
                Main.tile[n, numY10 - 1].active(false);
                Main.tile[n, numY10 - 2].active(false);
            }
            WorldGen.PlaceTile(numX9, numY10, 10, true, false, -1, doorStyle);

            numX9 = i + (width + 1) * -direction - direction;
            for (int n = minY; n <= maxY + 1; n++) {
                Main.tile[numX9, n].active(true);
                Main.tile[numX9, n].liquid = 0;
                Main.tile[numX9, n].type = (ushort) type;
                Main.tile[numX9, n].wall = 0;
                Main.tile[numX9, n].halfBrick(false);
                Main.tile[numX9, n].slope(0);
            }

            // Chest
            if (islandChestCount == chestContents.Count) {
                islandChestCount = WorldGen.genRand.Next(chestContents.Count);
            }
            WorldGen.AddBuriedChest(i, numY10 - 3, chestContents[islandChestCount], false, chestStyle);
            islandChestCount++;

            // Windows
            int num14 = i - width / 2 + 1;
            int num15 = i + width / 2 - 1;
            int num16 = 1;
            if (width > 10) {
                num16 = 2;
            }
            int num17 = (minY + maxY) / 2 - 1;
            for (int num18 = num14 - num16; num18 <= num14 + num16; num18++) {
                for (int num19 = num17 - 1; num19 <= num17 + 1; num19++) {
                    Main.tile[num18, num19].wall = (ushort) glass;
                }
            }
            for (int num20 = num15 - num16; num20 <= num15 + num16; num20++) {
                for (int num21 = num17 - 1; num21 <= num17 + 1; num21++) {
                    Main.tile[num20, num21].wall = (ushort) glass;
                }
            }

            // Furniture

            // Table
            int num22 = i + (width / 2 + 1) * -direction;
            WorldGen.PlaceTile(num22, maxY - 1, 14, true, false, -1, tableStyle);

            // Chairs
            WorldGen.PlaceTile(num22 - 2, maxY - 1, 15, true, false, 0, chairStyle);
            Tile tile = Main.tile[num22 - 2, maxY - 1];
            Tile expr_521 = tile;
            expr_521.frameX += 18;
            Tile tile2 = Main.tile[num22 - 2, maxY - 2];
            Tile expr_546 = tile2;
            expr_546.frameX += 18;
            WorldGen.PlaceTile(num22 + 2, maxY - 1, 15, true, false, 0, chairStyle);

            // Banners
            int i2 = minX + 1;
            int j2 = minY;
            WorldGen.PlaceTile(i2, j2, 91, true, false, -1, bannerStyle);
            i2 = maxX - 1;
            j2 = minY;
            WorldGen.PlaceTile(i2, j2, 91, true, false, -1, bannerStyle2);
            if (direction > 0) {
                i2 = minX;
                j2 = minY + 1;
            } else {
                i2 = maxX;
                j2 = minY + 1;
            }
            WorldGen.PlaceTile(i2, j2, 91, true, false, -1, bannerStyle3);

            // Altar & Orbs
            if (spreadType == SpreadType.Corruption || spreadType == SpreadType.Crimson) {
                num22 = i + (width / 2 + 1) * direction;
                WorldGen.Place3x2(num22, maxY - 1, TileID.DemonAltar, WorldGen.corruption ? 0 : 1); // altars
                genSomeOrbs(i, j); // orbs
            }

        }


    }
}
